var oe = Object.defineProperty;
var ne = (s, t, r) => t in s ? oe(s, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : s[t] = r;
var C = (s, t, r) => (ne(s, typeof t != "symbol" ? t + "" : t, r), r);
import { EditFormModel as ie, FormMDCtrlModel as le, AppEntityModel as Q } from "@ibiz-template/model";
import { useNamespace as S, useControlController as ce, usePropsWatch as de, getDatePickerProps as ue, getEditorEmits as Z, useController as me, getDataPickerProps as pe } from "@ibiz-template/vue-util";
import { defineComponent as x, getCurrentInstance as ee, ref as E, watch as B, h as a, onMounted as he } from "vue";
import { createUUID as q } from "qx-util";
import { ViewMode as W, PluginStaticResource as fe, UIActionHandler as ve, FrontUIActionHandler as ge, OpenAppViewCommand as ye } from "@ibiz-template/runtime";
import { EditFormController as De, FormMDCtrlController as Ee, DatePickerEditorController as Ce, UploadEditorController as be, PickerEditorController as Pe } from "@ibiz-template/controller";
import { ControlVO as we, calcResPath as te } from "@ibiz-template/service";
import $ from "dayjs";
import { isNil as J } from "ramda";
import { StringUtil as Fe } from "@ibiz-template/core";
class Ie extends De {
  constructor() {
    super(...arguments);
    /**
     *   基础数据
     *
     * @author fangZhiHao
     * @date 2024-04-26 17:04:49
     * @type {IData}
     */
    C(this, "baseResData", []);
    /**
     *   对比数据
     *
     * @author fangZhiHao
     * @date 2024-04-26 17:04:49
     * @type {IData}
     */
    C(this, "compareResData", []);
    /**
     * 表单旧数据
     *
     * @author zk
     * @date 2023-12-20 11:12:43
     * @protected
     * @type {IData}
     * @memberof FormController
     */
    C(this, "oldData", new we());
    /**
     * version数据
     *
     * @author fangZhiHao
     * @date 2024-04-26 16:04:37
     * @type {IData[]}
     */
    C(this, "versionData", []);
    /**
     *  对比数据
     *
     * @author fangZhiHao
     * @date 2024-04-26 16:04:37
     * @type {IData[]}
     */
    C(this, "comparisonArr", {});
    /**
     *  基础表格数据
     *
     * @author fangZhiHao
     * @date 2024-05-06 11:05:57
     * @type {IData[]}
     */
    C(this, "gridData", []);
    /**
     *  展示完全数据
     *
     * @author fangZhiHao
     * @date 2024-05-06 11:05:04
     * @type {IData[]}
     */
    C(this, "AllGridData", []);
    /**
     *  去除相同数据
     *
     * @author fangZhiHao
     * @date 2024-05-06 11:05:15
     * @type {IData[]}
     */
    C(this, "removeSameGridData", []);
    /**
     *  关系界面数据
     *
     * @author fangZhiHao
     * @date 2024-04-30 10:04:33
     * @type {IData}
     */
    C(this, "AlldruipartData", /* @__PURE__ */ new Map());
    /**
     *  关系界面数据长度
     *
     * @author fangZhiHao
     * @date 2024-05-06 11:05:56
     * @type {number}
     */
    C(this, "druipartDataSize", 0);
    /**
     *   关系界面实际数据
     *
     * @author fangZhiHao
     * @date 2024-05-06 11:05:13
     * @type {IData}
     */
    C(this, "newDruipartData", {});
  }
  /**
   * 加载数据
   *
   * @return {*}  {Promise<ControlVO>}
   * @memberof FormDataComparisonController
   */
  async loadGridData() {
    await this.startLoading();
    const r = this.model.source.M.getPSControlParam.ctrlParams, { BASEENTITY: n, COMPAREENTITY: i } = r, y = await ibiz.entityService.getService(n), h = await ibiz.entityService.getService(i), D = Object.assign({}, this.context.clone(), {
      [n.toLowerCase()]: this.params.base_version
    }), u = Object.assign({}, this.context.clone(), {
      [i.toLowerCase()]: this.params.compare_version
    }), p = await y.exec("Get", D, this.params), f = await h.exec(
      "Get",
      u,
      this.params
    );
    return this.isLoaded = !0, {
      baseData: p.data.data,
      compareData: f.data.data
    };
  }
  /**
   * 判断值是否为空
   *
   * @param {(string | IData[] | null | undefined)} value
   * @return {*}
   * @memberof FormDataComparisonController
   */
  isFalseyButNotEmpty(r) {
    return r == null || typeof r == "string" && r === "" || Array.isArray(r) && r.length === 0 || typeof r == "object" && Object.keys(r).length === 0;
  }
  /**
   * 比较两个值
   *
   * @param {IData} objA
   * @param {IData} objB
   * @return {*}
   * @memberof FormDataComparisonController
   */
  compareObjectValues(r, n) {
    return JSON.stringify(r) !== JSON.stringify(n);
  }
}
const Ne = x({
  name: "IBizFormDataComparison",
  props: {
    modelData: {
      type: ie,
      required: !0
    },
    context: {
      type: Object,
      required: !0
    },
    params: {
      type: Object,
      default: () => ({})
    },
    enableAutoSave: {
      type: Boolean,
      required: !1
    }
  },
  setup(s) {
    const t = S("form-data-comparison"), {
      proxy: r
    } = ee(), n = ce(r, () => {
      const e = new Ie(s.modelData, s.context, s.params);
      return de(r, "enableAutoSave", e.setEnableAutoSave.bind(e)), e;
    }), i = E(!0), y = E(!1), h = E({}), D = E({}), u = E([]), p = [], f = E([]), c = E([]), d = E([]), l = /* @__PURE__ */ new Map(), v = E(0), g = (e) => {
      const o = [];
      if (o.push(e), e && e.children) {
        const m = [];
        e.children.forEach((w) => {
          const N = g(w);
          m.push(...N);
        }), o.push(...m);
      }
      return o;
    }, b = g(s.modelData);
    p.push(...b);
    const P = (e) => {
      const o = n.details[e.source.name], m = a("not-supported-editor", {
        attrs: {
          modelData: e.editor
        }
      });
      return a("div", {
        class: [t.e("form-grid-item"), t.is("add", f.value.includes(e.source.name)), t.is("update", d.value.includes(e.source.name)), t.is("delete", c.value.includes(e.source.name))]
      }, [a("div", {
        class: t.em("form-grid-item", "name")
      }, [e.source.caption]), a("div", {
        class: t.em("form-grid-item", "left")
      }, [o.editorProvider ? a(o.editorProvider.formEditor, {
        props: {
          value: D.value[e.source.name],
          data: o.data,
          controller: o.editor,
          disabled: o.disabled,
          readonly: !0
        }
      }) : m]), a("div", {
        class: t.em("form-grid-item", "right")
      }, [o.editorProvider ? a(o.editorProvider.formEditor, {
        props: {
          value: h.value[e.source.name],
          data: o.data,
          controller: o.editor,
          disabled: o.disabled,
          readonly: !0
        }
      }) : m])]);
    }, I = (e, o) => {
      l.set(e.source.id, o), o.evt.on("mounted", () => {
        i.value && n.startLoading(), v.value += 1, o.call.refresh();
      }), o.evt.on("refreshed", () => {
        v.value -= 1, setTimeout(() => {
          i.value && n.endLoading();
        }, 500);
      });
    }, U = (e) => {
      const o = p.find((O) => O.id === `${e.source.id}_srfcopy`), m = e.embedView.source.modelPath, w = o == null ? void 0 : o.embedView.source.modelPath, N = n.context.clone(), F = {
        base_version: s.params.base_version
      }, A = n.context.clone();
      Object.assign(A, {
        gysrlzy_info: s.params.compare_version,
        compare_version: s.params.compare_version
      });
      const L = {
        compare_version: s.params.compare_version
      }, k = h.value[e.source.userTag], M = D.value[o == null ? void 0 : o.source.userTag];
      let V = !1, _ = !1, G = !1;
      if (e.source.userTag2) {
        const O = JSON.parse(e.source.userTag2), {
          comparekey: H,
          comparelist: re
        } = O;
        k && M && Array.isArray(k) && Array.isArray(M) && (k.length === 0 && M.length !== 0 ? G = !0 : k.length !== 0 && M.length === 0 ? V = !0 : k.length !== 0 && M.length !== 0 && (k.length !== M.length ? _ = !0 : k.some((K) => {
          const X = M.find((z) => K[H] === z[H]);
          return X ? re.some((z) => K[z] !== X[z] ? (_ = !0, !0) : !1) : (_ = !0, !0);
        })));
      }
      return a("div", {
        class: [t.e("druipart"), t.is("add", V), t.is("update", _), t.is("delete", G)]
      }, [a("div", {
        class: t.em("druipart", "caption")
      }, [e.source.caption]), a("div", {
        class: t.em("druipart", "left")
      }, [w && a("ViewShell", {
        attrs: {
          context: A,
          params: L,
          modal: {
            mode: W.EMBED
          },
          modelPath: w,
          noLoadDefault: !0,
          name: o == null ? void 0 : o.source.id
        },
        key: q(),
        on: {
          neuronInit: (O) => I(o, O)
        }
      })]), a("div", {
        class: t.em("druipart", "right")
      }, [m && a("ViewShell", {
        attrs: {
          context: N,
          params: F,
          modal: {
            mode: W.EMBED
          },
          modelPath: m,
          noLoadDefault: !0,
          name: e.source.id
        },
        key: q(),
        on: {
          neuronInit: (O) => I(e, O)
        }
      })])]);
    }, T = (e) => {
      const o = {
        modelData: e,
        controller: n.details[e.source.name]
      }, m = n.providers[e.source.name], w = a(m.component, {
        props: {
          ...o
        },
        key: e.id
      }), N = a(m.component, {
        props: {
          ...o
        },
        key: `compare_${e.id}`
      });
      return a("div", {
        class: t.e("mdctrl")
      }, [a("div", {
        class: t.em("mdctrl", "caption")
      }, [e.source.caption]), a("div", {
        class: t.em("mdctrl", "left")
      }, [w]), a("div", {
        class: t.em("mdctrl", "right")
      }, [N])]);
    }, R = (e) => {
      i.value = !1;
      const o = u.value.findIndex((m) => m === e.source.name);
      o > -1 ? u.value.splice(o, 1) : u.value.push(e.source.name);
    }, Y = (e) => {
      if (!e.source.hidden) {
        if (e.source.detailType === "FORMPAGE")
          return a("div", {
            class: t.e("form-page")
          }, [e.children.map((o) => Y(o))]);
        if (e.source.detailType === "FORMITEM") {
          const o = f.value.includes(e.source.name), m = c.value.includes(e.source.name), w = d.value.includes(e.source.name);
          return y.value && !o && !m && !w ? null : P(e);
        }
        if (e.source.detailType === "GROUPPANEL") {
          const o = u.value.includes(e.source.name);
          return a("div", {
            class: t.b("group")
          }, [a("div", {
            class: [t.be("group", "header"), t.is("hide-caption", !e.source.showCaption)]
          }, [a("div", {
            class: t.bem("group", "header", "name")
          }, [o ? a("i-icon", {
            class: t.bem("group", "header", "icon"),
            attrs: {
              type: "ios-arrow-forward",
              title: "展开"
            },
            on: {
              click: () => R(e)
            }
          }) : a("i-icon", {
            class: t.bem("group", "header", "icon"),
            attrs: {
              type: "ios-arrow-down",
              title: "收缩"
            },
            on: {
              click: () => R(e)
            }
          }), a("span", {
            class: t.bem("group", "header", "name-text")
          }, [e.source.caption || e.source.title])]), a("div", ["---"]), a("div", ["---"])]), a("div", {
            class: [t.be("group", "content"), t.is("collapse", o)]
          }, [e.children.map((m) => Y(m))])]);
        }
        return e.source.detailType === "DRUIPART" && !e.source.name.endsWith("_srfcopy") ? U(e) : e.source.detailType === "MDCTRL" ? T(e) : null;
      }
    }, j = (e, o) => {
      const m = [], w = [], N = [];
      return Object.keys(o).forEach((F) => {
        const A = e[F], L = o[F];
        n.isFalseyButNotEmpty(A) && !n.isFalseyButNotEmpty(L) && m.push(F), !n.isFalseyButNotEmpty(A) && !n.isFalseyButNotEmpty(L) && n.compareObjectValues(A, L) && w.push(F);
      }), Object.keys(e).forEach((F) => {
        if (!Object.prototype.hasOwnProperty.call(o, F) || n.isFalseyButNotEmpty(o[F])) {
          const A = e[F];
          n.isFalseyButNotEmpty(A) || N.push(F);
        }
      }), {
        added: m,
        modified: w,
        deleted: N
      };
    };
    return B(() => s.params, async () => {
      const e = await n.loadGridData();
      h.value = e.baseData, D.value = e.compareData;
      const {
        added: o,
        modified: m,
        deleted: w
      } = j(D.value, h.value);
      f.value = o, d.value = m, c.value = w;
    }, {
      immediate: !0
    }), {
      ns: t,
      c: n,
      switchValue: y,
      druipartNum: v,
      renderEditor: P,
      renderByDetailType: Y
    };
  },
  render() {
    return this.c.complete ? a("control-layout", {
      attrs: {
        modelData: this.c.model
      }
    }, [a("div", {
      class: this.ns.b()
    }, [a("div", {
      class: this.ns.e("top")
    }, [a("div", {
      class: this.ns.e("top-hidesame-content")
    }, [a("div", {
      class: this.ns.e("top-hidesame-content-left")
    }, ["隐藏相同项 ", a("i-switch", {
      model: {
        value: this.switchValue,
        callback: (s) => {
          this.switchValue = s;
        }
      }
    })]), a("div", {
      class: this.ns.e("top-hidesame-content-right")
    }, [a("div", {
      class: this.ns.e("top-hidesame-content-right-item")
    }, ["新增", a("div", {
      class: this.ns.e("top-hidesame-content-right-item-add")
    })]), a("div", {
      class: this.ns.e("top-hidesame-content-right-item")
    }, ["修改", a("div", {
      class: this.ns.e("top-hidesame-content-right-item-change")
    })]), a("div", {
      class: this.ns.e("top-hidesame-content-right-item")
    }, ["删除", a("div", {
      class: this.ns.e("top-hidesame-content-right-item-delete")
    })])])]), a("div", {
      class: this.ns.e("top-content")
    }, [a("div", {
      class: this.ns.em("top-content", "attr")
    }, ["信息项"]), a("div", {
      class: [this.ns.em("top-content", "left")]
    }, ["更新前内容"]), a("div", {
      class: [this.ns.em("top-content", "right")]
    }, ["更新后内容"])])]), a("div", {
      class: this.ns.e("content")
    }, [this.modelData.children.map((s) => this.renderByDetailType(s))])])]) : null;
  }
});
const Ae = x({
  name: "CustomDataImport",
  props: {
    templateUrl: {
      type: String,
      required: !0
    },
    importUrl: {
      type: String,
      required: !0
    },
    dismiss: {
      type: Function
    }
  },
  setup(s, {
    emit: t
  }) {
    const r = S("data-import"), n = E(), i = E({
      state: "ready",
      message: "",
      rowError: []
    }), y = E(""), h = async (c) => {
      const d = new FormData(), l = $(y.value).format("YYYY-MM");
      d.append("file", c), d.append("ny", l);
      try {
        const v = await ibiz.net.request(s.importUrl, {
          method: "post",
          data: d,
          headers: {
            "Content-Type": "multipart/form-data"
          }
        });
        i.value.state = "success", i.value.message = "导入成功";
        const {
          errorinfo: g,
          success: b,
          total: P
        } = v.data, I = P ? Number(P) : 0, U = b ? Number(b) : 0, T = P - b;
        i.value.message = `共计导入数据 ${I} 条，错误[${T}]，成功[${U}]`, g && Object.keys(g).length > 0 && (i.value.rowError = [], Object.keys(g).forEach((R) => {
          i.value.rowError.push({
            index: Number(R) + 1,
            info: g[R].errorInfo
          });
        }));
      } catch (v) {
        i.value.state = "fail", i.value.message = `导入失败！${v.message}`;
      }
    }, D = (c) => {
      const d = c.target;
      if (!d.files)
        return;
      const l = d.files[0];
      d.value = null, h(l);
    }, u = async () => {
      var d;
      const c = await ibiz.net.request(s.templateUrl, {
        responseType: "blob"
      });
      if (c.status === 200) {
        let l = ((d = c.headers["content-disposition"].split(";").find((b) => b.indexOf("filename=") !== -1)) == null ? void 0 : d.slice(9)) || "";
        l = decodeURIComponent(l);
        const v = new Blob([c.data], {
          type: "application/vnd.ms-excel"
        }), g = document.createElement("a");
        g.download = l, g.style.display = "none", g.href = URL.createObjectURL(v), document.body.appendChild(g), g.click(), URL.revokeObjectURL(g.href), document.body.removeChild(g);
      }
    }, p = () => {
      n.value.click();
    }, f = () => {
      var c;
      t("close", {
        ok: !1,
        data: {}
      }), (c = s.dismiss) == null || c.call(s, {
        ok: !1,
        data: {}
      });
    };
    return he(() => {
      y.value = $().format("YYYY年MM月");
    }), {
      ns: r,
      curDate: y,
      onLinkClick: u,
      selectFile: p,
      onCancelButtonClick: f,
      onFileChange: D,
      inputUpLoad: n,
      message: i
    };
  },
  render() {
    return a("div", {
      class: [this.ns.b(), this.ns.is("custom", !0)]
    }, [a("input", {
      ref: "inputUpLoad",
      attrs: {
        type: "file",
        accept: "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"
      },
      style: "display: none",
      on: {
        change: this.onFileChange
      }
    }), a("div", {
      class: this.ns.e("caption")
    }, ["导入数据"]), a("div", {
      class: this.ns.e("date")
    }, [a("span", ["导入数据所属月份"]), a("i-datePicker", {
      attrs: {
        format: "yyyy年MM月",
        type: "month",
        clearable: !1
      },
      model: {
        value: this.curDate,
        callback: (s) => {
          this.curDate = s;
        }
      }
    })]), this.message.state === "ready" ? a("div", {
      class: this.ns.b("upload"),
      on: {
        click: this.selectFile
      }
    }, [a("img", {
      class: this.ns.be("upload", "img"),
      attrs: {
        src: "./assets/img/icon-import.svg"
      }
    }), a("span", {
      class: this.ns.be("upload", "text")
    }, ["单击此区域进行上传"])]) : a("div", {
      class: this.ns.b("message")
    }, [a("div", {
      class: this.ns.be("message", "title")
    }, ["导入结果"]), a("div", {
      class: this.ns.be("message", "content")
    }, [this.message.message]), this.message.rowError.length > 0 && [a("div", {
      class: this.ns.be("message", "title")
    }, ["错误信息"]), a("div", {
      class: this.ns.be("message", "content")
    }, [this.message.rowError.map((s) => a("div", [`第 ${s.index} 行：${s.info}`]))])]]), a("div", {
      class: this.ns.e("template-container")
    }, [a("div", {
      class: this.ns.e("template-description")
    }, ["下载导入模版，并按要求填写："]), a("div", {
      class: this.ns.e("template-link"),
      on: {
        click: this.onLinkClick
      }
    }, [a("i-icon", {
      attrs: {
        type: "ios-link"
      }
    }), "数据导入模板文件"])]), a("div", {
      class: this.ns.e("button-bar")
    }, [this.message.state !== "ready" && a("i-button", {
      on: {
        click: this.selectFile
      }
    }, ["重新上传"])])]);
  }
});
const ke = x({
  name: "YearMonthPicker",
  props: ue(),
  emits: Z(),
  setup(s, {
    emit: t
  }) {
    const r = S("date-picker"), n = s.controller, i = n.model, y = E("date"), h = E("yyyy-MM-dd"), D = E(!1);
    switch (i.editorType) {
      case "DATEPICKEREX":
      case "DATEPICKEREX_NOTIME":
        y.value = "date";
        break;
      case "DATEPICKEREX_NODAY":
      case "DATEPICKEREX_NODAY_NOSECOND":
        D.value = !0, y.value = "time";
        break;
      case "DATEPICKEREX_HOUR":
      case "DATEPICKEREX_MINUTE":
      case "DATEPICKEREX_SECOND":
      case "DATEPICKEREX_NOSECOND":
      case "DATEPICKER":
      default:
        y.value = "datetime";
    }
    const u = n.valueFormat;
    if (u) {
      u === "YYYY-MM" ? y.value = "month" : u === "YYYY" && (y.value = "year");
      const l = u.replace("YYYY", "yyyy").replace("DD", "dd");
      h.value = l;
    }
    i.editorParams.formatText && (h.value = i.editorParams.formatText.replace("YYYY", "yyyy").replace("DD", "dd"));
    const p = E();
    B(() => s.value, (l, v) => {
      l && l !== v && (p.value = $(l).format(u));
    }, {
      immediate: !0
    });
    const f = (l, v) => {
      if (l) {
        const g = $(l.replace(/[年月]/g, "-")).format(u);
        t("change", g);
      } else
        t("change", l);
    }, c = (l) => {
      t("operate", l);
    }, d = E();
    return s.autoFocus && B(d, (l) => {
      l && l.$el.getElementsByTagName("input")[0].click();
    }), {
      ns: r,
      c: n,
      editorModel: i,
      type: y,
      format: h,
      formatValue: p,
      handleChange: f,
      onOpenChange: c,
      inputRef: d,
      isTimePicker: D
    };
  },
  render(s) {
    return s("div", {
      class: [this.ns.b(), this.disabled ? this.ns.m("disabled") : "", this.readonly ? this.ns.m("readonly") : ""]
    }, [[this.readonly && this.formatValue, !this.readonly && this.isTimePicker && s("ITimePicker", {
      ref: "inputRef",
      props: {
        ...this.c.customProps,
        value: this.value,
        type: this.type,
        format: this.format,
        placeholder: this.c.placeHolder,
        disabled: this.disabled,
        transfer: !0
      },
      on: {
        "on-change": this.handleChange,
        "on-open-change": this.onOpenChange
      }
    }), !this.readonly && !this.isTimePicker && s("ICalendarPicker", {
      ref: "inputRef",
      props: {
        ...this.c.customProps,
        value: this.value,
        type: this.type,
        format: this.format,
        placeholder: this.c.placeHolder,
        disabled: this.disabled,
        transfer: !0
      },
      on: {
        "on-change": this.handleChange,
        "on-open-change": this.onOpenChange
      }
    })]]);
  }
});
const ae = new fe(import.meta.url), Me = x({
  name: "DownLoadSafeFile",
  props: {},
  setup() {
    const s = S("download-safe-file"), t = ae.dir("/assets/doc/safe-file.doc");
    return {
      ns: s,
      url: t
    };
  },
  render() {
    return a("div", {
      class: this.ns.b()
    }, [a("a", {
      attrs: {
        download: "网络信息安全承诺书.doc",
        href: this.url
      }
    }, ["网络信息安全承诺书.doc"])]);
  }
});
class se extends Ee {
  connect(t, r) {
    this.formNeurons.get(t) || (this.formNeurons.set(t, r), r.evt.on("mounted", () => {
      r.call.load();
    }), r.evt.on("destroyed", () => {
      this.formNeurons.delete(t);
    }), r.evt.on("valueChange", (n) => {
      if (n) {
        const i = this.contentCtrlData.find((y) => y.srfkey === n.srfkey);
        i && Object.assign(i, n), this.force();
      }
    }));
  }
}
const Oe = x({
  name: "FormMDCtrlFormStyle2",
  props: {
    controller: {
      type: se,
      required: !0
    },
    modelData: {
      type: le,
      required: !0
    }
  },
  setup(s) {
    const t = S("form-mdctrl-form-style2"), r = s.controller, n = E(0), {
      proxy: i
    } = ee();
    me(i, s.controller);
    const y = async (p, f, c) => {
      c.stopPropagation(), c.preventDefault();
      const d = r.contentCtrlData.length;
      await r.handleRemove(p, f), d !== r.contentCtrlData.length && f <= n.value && n.value !== 0 && (n.value -= 1);
    }, h = (p) => {
      n.value = p, r.force();
    }, D = () => {
      const p = s.modelData.source.userTag;
      let f = {};
      p && (f = JSON.parse(p));
      const {
        tabtitle: c,
        addtitle: d
      } = f;
      return a("div", {
        class: t.e("header")
      }, [r.contentCtrlData.map((l, v) => {
        let g = `新建${v + 1}`;
        return l.srfmajortext ? g = l.srfmajortext : c && l[c] ? g = l[c] : d && (g = `${d}${v + 1}`), a("div", {
          class: [t.e("header-item"), t.is("actived", v === n.value)],
          on: {
            click: () => h(v)
          }
        }, [a("div", {
          class: t.em("header-item", "title")
        }, [g]), a("div", {
          class: t.em("header-item", "delete"),
          attrs: {
            title: "移除"
          },
          on: {
            click: (b) => y(l, v, b)
          }
        }, [a("i", {
          class: "fa fa-close"
        })])]);
      }), a("div", {
        class: [t.e("header-item"), t.e("add")],
        attrs: {
          title: "添加"
        },
        on: {
          click: () => r.handleAdd()
        }
      }, [a("span", ["添加"]), a("i", {
        class: "fa fa-plus"
      })])]);
    };
    return B(() => r.form.isLoaded, (p, f) => {
      p !== f && p === !0 && r.loadData();
    }), {
      ns: t,
      rendertanHeader: D,
      renderTabs: () => r.contentCtrlData.map((p, f) => {
        var l;
        let c = null;
        const {
          form: d
        } = r.model;
        if (d && r.providers[d.name] && r.model.appEntity) {
          const v = Object.assign(r.form.context.clone(), {
            [(l = r.model.appEntity.codeName) == null ? void 0 : l.toLowerCase()]: p[r.model.appEntity.keyName]
          });
          c = a(r.providers[d.name].component, {
            props: {
              modelData: d,
              context: v,
              params: r.form.params,
              enableAutoSave: !0,
              silentVerify: !0
            },
            on: {
              neuronInit: r.onNeuronInit(p.srfkey)
            }
          });
        }
        return a("div", {
          class: [t.e("content"), t.is("actived", f === n.value)],
          key: p.srfkey
        }, [c]);
      })
    };
  },
  render() {
    return a("div", {
      class: this.ns.b()
    }, [this.rendertanHeader(), this.renderTabs()]);
  }
});
const Se = x({
  name: "IBizPickerDropDownIcon",
  props: pe(),
  emits: Z(),
  setup(s, {
    emit: t
  }) {
    const r = S("picker-dropdown"), n = S("picker-dropdown-icon"), i = s.controller, y = E(""), h = E([]), D = E(!1), u = E(!1), p = E(!1), f = E(""), c = E(!1);
    B(() => s.value, (e, o) => {
      if (e || e === null) {
        o == null && (D.value = !0), y.value = e;
        const m = s.data[i.valueItem];
        if (h.value.findIndex((N) => Object.is(N[i.keyName], m)) !== -1)
          return;
        h.value = [], !J(e) && !J(m) && h.value.push({
          [i.textName]: e,
          [i.keyName]: m
        });
      }
    }, {
      immediate: !0
    });
    const d = E("");
    B(() => s.data[i.valueItem], (e, o) => {
      e !== o && (d.value = e, e === null && t("change", null));
    }, {
      immediate: !0,
      deep: !0
    });
    const l = E(!1), v = async (e) => {
      const o = await i.calcFillDataItems(e);
      o.length && o.forEach((m) => {
        t("change", m.value, m.name);
      }), i.valueItem && t("change", e[i.keyName], i.valueItem), t("change", e[i.textName]);
    }, g = (e) => {
      const o = h.value.findIndex((m) => Object.is(m[i.keyName], e));
      o >= 0 && v(h.value[o]), c.value = !0;
    };
    let b = null;
    const P = async (e) => {
      if (i.model.appDataEntity && l.value === !1) {
        l.value = !0, D.value && (f.value = d.value, d.value = "");
        try {
          const o = D.value ? "" : e, m = await i.getServiceData(o, s.data);
          m && (h.value = m.data);
        } finally {
          if (l.value = !1, b != null) {
            const o = b;
            b = null, await P(o);
          }
        }
      } else
        b = e;
      D.value = !1;
    }, I = (e) => {
      t("operate", e), e ? (h.value = [], P("")) : c.value || (d.value = f.value), p.value = e;
    }, U = (e) => {
      e === "" && P("");
    }, T = () => {
      var o;
      const e = (o = i.model.deACMode) == null ? void 0 : o.dataItems;
      e != null && e.length && e.forEach((m) => {
        t("change", null, m.name);
      }), i.valueItem && t("change", null, i.valueItem), t("change", null);
    };
    return {
      ns: r,
      c: i,
      refValue: d,
      loading: l,
      items: h,
      ns1: n,
      onOpenChange: I,
      onQueryChange: U,
      onClear: T,
      onSelect: g,
      onSearch: P,
      renderIcon: () => s.value && u.value ? a("i", {
        class: "ivu-icon ivu-icon-ios-close-circle ivu-select-arrow",
        on: {
          click: T
        }
      }) : a("i", {
        class: "ivu-icon ivu-icon-ios-arrow-down ivu-select-arrow"
      }),
      onMouseEnter: () => {
        u.value = !0;
      },
      onMouseLevel: () => {
        u.value = !1;
      }
    };
  },
  render(s) {
    return this.readonly ? s("div", {
      class: (this.ns.b(), this.ns.m("readonly"))
    }, [this.value]) : s("div", {
      class: [this.ns.b(), this.ns1.b(), this.disabled ? this.ns.m("disabled") : ""],
      on: {
        mouseenter: this.onMouseEnter,
        mouseleave: this.onMouseLevel
      }
    }, [[this.readonly && this.value, !this.readonly && s("iSelect", {
      props: {
        ...this.c.customProps,
        value: this.refValue,
        filterable: !0,
        remote: !0,
        allowClear: !0,
        clearable: !0,
        transfer: !0,
        loading: this.loading,
        placeholder: this.c.placeHolder,
        remoteMethod: this.onSearch,
        disabled: this.disabled
      },
      on: {
        "on-change": this.onSelect,
        "on-open-change": this.onOpenChange,
        "on-query-change": this.onQueryChange,
        "on-clear": this.onClear
      }
    }, [this.items.map((t, r) => s("i-option", {
      attrs: {
        value: t[this.c.keyName]
      },
      key: r
    }, [t[this.c.textName]]))]), this.renderIcon()]]);
  }
});
class Te {
  constructor() {
    C(this, "component", "IBizFormDataComparison");
  }
}
class Re extends ve {
  async execAction(t, r, n, i) {
    const y = {}, h = t.getPSAppDataEntity();
    if (h) {
      h.isFill === !1 && await h.fill(!0);
      const D = new Q(h);
      await D.init();
      const { resultContext: u } = await this.handleParams(
        t,
        r,
        n,
        i
      ), p = ibiz.resourcePathUtil.calcPaths(
        u,
        D.codeName
      ), f = te(u, p);
      let c = `${f}/${D.deNamePlural}/importtemplate`, d = `${f}/${D.deNamePlural}/importdata2`;
      const l = t.getPSAppDEDataImport();
      l && (c += `?srfimporttag=${l.codeName}`, d += `?srfimporttag=${l.codeName}`);
      const v = ibiz.overlay.createModal(
        "CustomDataImport",
        {
          templateUrl: c,
          importUrl: d,
          dismiss: (g) => {
            v.dismiss(g);
          }
        },
        {
          width: "auto",
          placement: "center"
        }
      );
      return v.present(), await v.onWillDismiss(), {
        refresh: !0
      };
    }
    return y;
  }
}
class Be {
  constructor() {
    C(this, "handler");
  }
  async getHandler() {
    return this.handler || (this.handler = new Re()), this.handler;
  }
}
class xe {
  constructor() {
    C(this, "gridEditor", "YearMonthPicker");
    C(this, "formEditor", "YearMonthPicker");
  }
  async createController(t, r) {
    const n = new Ce(t, r);
    return await n.init(), n;
  }
}
class Ue {
  constructor() {
    C(this, "formEditor", "DownLoadSafeFile");
    C(this, "gridEditor", "DownLoadSafeFile");
  }
  async createController(t, r) {
    const n = new be(t, r);
    return await n.init(), n;
  }
}
class Le extends ge {
  async execAction(t, r, n, i, y) {
    const h = {}, { frontProcessType: D } = t;
    if (D === "OPENHTMLPAGE") {
      const u = Fe.fill(t.htmlPageUrl, r, n == null ? void 0 : n[0]);
      window.open(u, "_blank");
    }
    if (D === "DATAIMP") {
      const u = t.getPSAppDataEntity();
      if (u) {
        u.isFill === !1 && await u.fill(!0);
        const p = new Q(u);
        await p.init();
        const { resultContext: f } = await this.handleParams(
          t,
          r,
          n,
          i
        ), c = ibiz.resourcePathUtil.calcPaths(
          f,
          p.codeName
        ), d = te(f, c);
        let l = `${d}/${p.deNamePlural}/importtemplate`, v = `${d}/${p.deNamePlural}/importdata2`;
        const g = t.getPSAppDEDataImport();
        g && (l += `?srfimporttag=${g.codeName}`, v += `?srfimporttag=${g.codeName}`);
        const b = ibiz.overlay.createModal(
          "DataImport",
          {
            templateUrl: l,
            importUrl: v,
            dismiss: (P) => {
              b.dismiss(P);
            }
          },
          {
            width: "auto",
            placement: "center"
          }
        );
        return b.present(), await b.onWillDismiss(), {
          refresh: !0
        };
      }
    }
    if (["TOP", "WIZARD"].includes(D)) {
      const u = t.getFrontPSAppView();
      if (!u)
        throw new Error("未配置打开视图");
      await u.fill(!0);
      const { resultContext: p, resultParams: f } = await this.handleParams(
        t,
        r,
        n,
        i
      ), c = await ibiz.commands.execute(
        ye.TAG,
        u,
        p,
        f,
        y
      );
      (c == null ? void 0 : c.ok) === !1 && (h.closeView = !1, h.refresh = !1, h.cancel = !0), c != null && c.ok && c.data && (h.data = c.data);
    } else if (y) {
      const { neuron: u } = y, f = u.call.getFormController().call.getFormController(), { druipart1: c, druipart2: d, druipart3: l } = f.details;
      [
        {
          message: "服务履历为空",
          neuron: c
        },
        {
          message: "教育经验为空",
          neuron: d
        },
        {
          message: "项目经验为空",
          neuron: l
        }
      ].some((b) => {
        const P = b.neuron.neuron.call.getGridController();
        if (P) {
          const I = P.call.getGridController();
          if (I && I.items && I.items.length > 0)
            return !1;
        }
        return ibiz.message.error(`${b.message}`, 1.5, !0), !0;
      }) || await u.call.wfStart();
    }
    return h;
  }
}
class Ye {
  constructor() {
    C(this, "handler");
  }
  async getHandler() {
    return this.handler || (this.handler = new Le()), this.handler;
  }
}
class _e {
  constructor() {
    C(this, "component", "FormMDCtrlFormStyle2");
  }
  async createController(t, r, n) {
    const i = new se(t, r, n);
    return await i.init(), i;
  }
}
class ze {
  constructor() {
    C(this, "formEditor", "IBizPickerDropDownIcon");
    C(this, "gridEditor", "IBizGridPicker");
  }
  async createController(t, r) {
    const n = new Pe(t, r);
    return await n.init(), n;
  }
}
const Ze = {
  mateUrl: import.meta.url,
  install(s) {
    ae.loadStyle(["/style.css"]), s.component("IBizFormDataComparison", Ne), s.component("CustomDataImport", Ae), s.component("YearMonthPicker", ke), s.component("DownLoadSafeFile", Me), s.component("FormMDCtrlFormStyle2", Oe), s.component("IBizPickerDropDownIcon", Se), ibiz.register.control.register(
      "EDITFORM_RENDER_FORM_DATA_COMPARISON",
      new Te()
    ), ibiz.register.uiAction.register(
      "DEUIACTION_CUSTOM_IMPORT",
      new Be()
    ), ibiz.register.editor.register(
      "DATEPICKEREX_NOTIME_YEAR_MONTH_PICKER",
      new xe()
    ), ibiz.register.editor.register(
      "FILEUPLOADER_ONE_DOWNLOAD_FILE",
      new Ue()
    ), ibiz.register.uiAction.register(
      "DEUIACTION_JUDEG_ENABLE_UPDATE",
      new Ye()
    ), ibiz.register.formDetail.register(
      "FORM_USERCONTROL_MUL_FORM_CARD",
      new _e()
    ), ibiz.register.editor.register(
      "PICKEREX_TRIGGER_HAS_DROPDOWN_ICON",
      new ze()
    );
  }
};
export {
  Ze as default
};
